/*----------------------------------------------------------------------+
|									|
|  Copyright (1995) Bentley Systems, Inc., All rights reserved.		|
|									|
|  "MicroStation" is a registered trademark and "MDL" and "MicroCSL"	|
|  are trademarks of Bentley Systems, Inc.			    	|
|									|
|  Limited permission is hereby granted to reproduce and modify this	|
|  copyrighted material provided that the resulting code is used only 	|
|  in conjunction with Bentley Systems products under the terms of the	|
|  license agreement provided therein, and that this notice is retained	|
|  in its entirety in any such reproduction or modification.		|
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|    $Logfile:   J:/mdl/examples/doc/params.mcv  $
|   $Workfile:   params.mc  $
|   $Revision:   5.2  $
|   	$Date:   20 Jun 1995 08:49:48  $
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|   params.mc - examples for the mdlParams_ functions.			|
|									|
|   This file is intended as an adjunct to the MDL manual to		|
|   illustrate MDL built-in function calling conventions and parameter	|
|   values. While it can be compiled, it does NOT, on its own,		|
|   constitute a workable MDL example.					|
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|   Include Files   							|
|									|
+----------------------------------------------------------------------*/
#include    <mdl.h>	    /* system include files */
#include    <global.h>
#include    <mselems.h>

/*----------------------------------------------------------------------+
|									|
| name		dumpActiveParameters					|
|									|
| author	BSI     				7/90		|
|									|
+----------------------------------------------------------------------*/
Public void	dumpActiveParameters
(
void	
)
    {
    Dpoint3d	tPt;
    double	dTemp, dTemp1;
    int		color, temp, param;
    char	name[30];

    mdlCurrTrans_begin();
    mdlCurrTrans_masterUnitsIdentity (TRUE);
		    
    /* active color number and name */
    mdlParams_getActive (&color, ACTIVEPARAM_COLOR);
    mdlParams_getActive (name,   ACTIVEPARAM_COLOR_BY_NAME);
    printf ("color=[%d], [%s]\n", color, name);

    /* active line style */
    mdlParams_getActive (&temp, ACTIVEPARAM_LINESTYLE);
    printf ("linestyle=%d\n", temp);
    
    /* active line weight */
    mdlParams_getActive (&temp, ACTIVEPARAM_LINEWEIGHT);
    printf ("lineweight=%d\n", temp);
    
    /* active level */
    mdlParams_getActive (&temp, ACTIVEPARAM_LEVEL);
    printf ("level=%d\n", temp);
    
    /* active angle */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_ANGLE);
    printf ("angle=%f\n", dTemp);
    
    /* active scale */
    mdlParams_getActive (&tPt, ACTIVEPARAM_SCALE);
    printf ("scale factors=[%f,%f,%f]\n", tPt.x, tPt.y, tPt.z);

    /* active font */
    mdlParams_getActive (&temp, ACTIVEPARAM_FONT);
    printf ("Font=%d\n", temp);
    
    /* active grid units and grids per reference grid */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_GRIDUNITS);
    mdlParams_getActive (&temp, ACTIVEPARAM_GRIDREF);
    printf ("grid units=%f, grids per ref = %d\n", dTemp, temp);
    
    /* active text size */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_TEXTHEIGHT);
    mdlParams_getActive (&dTemp1, ACTIVEPARAM_TEXTWIDTH);
    printf ("text width=%f, height=%f\n", dTemp);

    /* active unit roundoff */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_UNITROUNDOFF);
    printf ("unit roundoff=%f\n", dTemp);
    
    /* text justification */
    mdlParams_getActive (&temp, ACTIVEPARAM_TEXTJUST);
    printf ("Text just=%d\n", temp);
    
    /* text node justification */
    mdlParams_getActive (&temp, ACTIVEPARAM_NODEJUST);
    printf ("Node just=%d\n", temp);
    
    /* active cell name */
    mdlParams_getActive (name, ACTIVEPARAM_CELLNAME);
    printf ("Cell=[%s]\n", name);
    
    /* active line length */
    mdlParams_getActive (&temp, ACTIVEPARAM_LINELENGTH);
    printf ("line length=%d\n", temp);
    
    /* active line spacing */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_LINESPACING);
    printf ("line spacing=%f\n", dTemp);
    
    /* active line terminator */
    mdlParams_getActive (name, ACTIVEPARAM_TERMINATOR);
    printf ("Terminator Cell=%s\n", name);

    /* active line terminator scale */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_TERMINATORSCALE);
    printf ("Line terminator scale factor =%d\n", dTemp);
    
    /* active tag increment */
    mdlParams_getActive (&temp, ACTIVEPARAM_TAGINCREMENT);
    printf ("tag incr=%d\n", temp);
    
    /* active tab for "INCLUDE TEXT" command */
    mdlParams_getActive (&temp, ACTIVEPARAM_TAB);
    printf ("tab=%d\n", temp);
    
    /* digitizing parameters */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_STREAMDELTA);
    printf ("stream delta=%f\n", dTemp);
    mdlParams_getActive (&dTemp, ACTIVEPARAM_STREAMTOLERANCE);
    printf ("stream tol=%f\n", dTemp);
    mdlParams_getActive (&dTemp, ACTIVEPARAM_STREAMANGLE);
    printf ("stream angle=%f\n", dTemp);
    mdlParams_getActive (&dTemp, ACTIVEPARAM_STREAMAREA);
    printf ("stream area=%f\n", dTemp);
    
    /* active point */
    mdlParams_getActive (name, ACTIVEPARAM_POINT);
    printf ("point cell=%s\n", name);
    
    /* keypoint divisor */
    mdlParams_getActive (&temp, ACTIVEPARAM_KEYPOINT);
    printf ("active keypnt=%d\n", temp);
    
    /* patterning parameters */
    mdlParams_getActive (&tPt, ACTIVEPARAM_PATTERNDELTA);
    printf ("pattern delta=[%f,%f]\n", tPt.x, tPt.y);
    mdlParams_getActive (&tPt, ACTIVEPARAM_PATTERNANGLE);
    printf ("pattern angle=[%f,%f]\n", tPt.x, tPt.y);
    mdlParams_getActive (&dTemp, ACTIVEPARAM_PATTERNSCALE);
    printf ("pattern scale=%f\n", dTemp);
    mdlParams_getActive (name, ACTIVEPARAM_PATTERNCELL);
    printf ("pattern cell=%s\n", name);
    
    /* active area mode */
    mdlParams_getActive (&temp, ACTIVEPARAM_AREAMODE);
    printf ("area mode=%d\n", temp);
    
    /* active axis angle */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_AXISANGLE);
    printf ("axis angle=%f\n", dTemp);
    
    /* capped surface mode */
    mdlParams_getActive (&temp, ACTIVEPARAM_CAPMODE);
    printf ("cap mode=%s\n", temp ? "ON" : "OFF");
    
    /* grid mode */
    mdlParams_getActive (&temp, ACTIVEPARAM_GRIDMODE);
    printf ("grid mode = %s\n", temp ? "ISO" : "NORMAL");
    
    /* active drawing class */
    mdlParams_getActive (&temp, ACTIVEPARAM_CLASS);
    printf ("class=%d\n", temp);
    
    /* active grid ratio (if ISO mode is enabled) */
    mdlParams_getActive (&dTemp, ACTIVEPARAM_GRIDRATIO);
    printf ("grid ratio=%f\n", dTemp);
    
    /* active fill mode */
    mdlParams_getActive (&temp, ACTIVEPARAM_FILLMODE);
    printf ("fill mode=%d\n", temp ? "ON" : "OFF");

    mdlCurrTrans_end ();
    }

/*----------------------------------------------------------------------+
|									|
| name		setParamsToKnownValues					|
|									|
| author	BSI     				8/90		|
|									|
+----------------------------------------------------------------------*/
Public void	setParamsToKnownValues
(
void
)
    {
    Dpoint3d	tPt;
    double	dTemp;

    mdlCurrTrans_begin();
    mdlCurrTrans_masterUnitsIdentity (TRUE);
    
#if defined (useColorName)
    mdlParams_setActive ("RED", ACTIVEPARAM_COLOR_BY_NAME);
#else
    mdlParams_setActive (1, ACTIVEPARAM_COLOR);
#endif
    
    mdlParams_setActive (3, ACTIVEPARAM_LINESTYLE);
    mdlParams_setActive (4, ACTIVEPARAM_LINEWEIGHT);
    mdlParams_setActive (44, ACTIVEPARAM_LEVEL);
    
    dTemp = 101.1;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_ANGLE);
    mdlParams_setActive (55, ACTIVEPARAM_FONT);

    tPt.x = 1.1;
    tPt.y = 2.2;
    tPt.z = 3.3;
    mdlParams_setActive (&tPt, ACTIVEPARAM_SCALE);
    dTemp = 12;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_GRIDUNITS);
    mdlParams_setActive (4, ACTIVEPARAM_GRIDREF);

    dTemp = 1.1;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_TEXTHEIGHT);

    dTemp = 1.2;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_TEXTWIDTH);

    dTemp = 2.1;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_UNITROUNDOFF);
    mdlParams_setActive (5, ACTIVEPARAM_TEXTJUST);
    mdlParams_setActive (3, ACTIVEPARAM_NODEJUST);

    mdlParams_setActive ("TRUCK", ACTIVEPARAM_CELLNAME);
    mdlParams_setActive (33, ACTIVEPARAM_LINELENGTH);
    dTemp = 1.7;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_LINESPACING);

    mdlParams_setActive ("ARROW", ACTIVEPARAM_TERMINATOR);
    mdlParams_setActive (2, ACTIVEPARAM_TAGINCREMENT);
    mdlParams_setActive (9, ACTIVEPARAM_TAB);

    dTemp = 4.2;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_STREAMDELTA);
    dTemp = 4.104;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_STREAMTOLERANCE);
    dTemp = 11.;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_STREAMANGLE);

    dTemp = 3.2;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_STREAMAREA);
    mdlParams_setActive ("SQUARE", ACTIVEPARAM_POINT);
    mdlParams_setActive (4, ACTIVEPARAM_KEYPOINT);

    tPt.x = 5.5;
    tPt.y = 6.6;
    mdlParams_setActive (&tPt, ACTIVEPARAM_PATTERNDELTA);
    tPt.x = 7.7;
    tPt.y = 8.8;
    mdlParams_setActive (&tPt, ACTIVEPARAM_PATTERNANGLE);
    dTemp = 9.9;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_PATTERNSCALE);
    mdlParams_setActive ("HASH", ACTIVEPARAM_PATTERNCELL);

    mdlParams_setActive (1, ACTIVEPARAM_AREAMODE);
    dTemp = 10.1;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_AXISANGLE);
    mdlParams_setActive (1, ACTIVEPARAM_CAPMODE);
    mdlParams_setActive (1, ACTIVEPARAM_GRIDMODE);
    
    mdlParams_setActive (3, ACTIVEPARAM_CLASS);
    dTemp =2.1;
    mdlParams_setActive (&dTemp, ACTIVEPARAM_GRIDRATIO);
    mdlParams_setActive (1, ACTIVEPARAM_FILLMODE);
    mdlCurrTrans_end ();
    }
